<?php

require 'vendor/autoload.php';

$api = array("connected" => false,
             "logged"    => false,
             "status"    => "idle",
             "user"      => "admin",
             "pass"      => "12345",
             "addr"      => "10.0.0.123",
             "port"      => "8000"
            );

$loop = React\EventLoop\Factory::create();
$connector = new React\Socket\Connector($loop,array('timeout' => 10.0));
$connector->connect("{$api['addr']}:{$api['port']}")->then(
    function (React\Socket\ConnectionInterface $connection) use ($loop, &$api){

        echo "connection successfully established\n";
        $api['connected'] = true;

        echo "Add Timer to call 1000....\n";
        $timer = $loop->addTimer(5, function () use ($connection, &$api) {
            if($api['logged'] == true) {
                echo "Dial to 1000...\n";
                $connection->write("DIAL TO:1000\r\n\r\n");
            } else {
                echo "CTI cli not logged!\n";
            }
        });

        $connection->on('data', function ($data) use (&$api) {
            echo "RECV:$data";

            if(strncmp($data, "LOGIN", 5) == 0){
                if(strstr($data, "RESP:OK")){ 
                    echo "Login OK\n";
                    $api['logged'] = true;
                } else
                    echo "Login Error!\n";
            }
        });

        $connection->on('end', function () {
            echo "Connection ended\n";
        });

        $connection->on('error', function (Exception $e) {
            echo 'Connection error: ' . $e->getMessage() . "\n";
        });

        $connection->on('close', function () {
            $api['connected'] = false;
            echo "Connection closed...\n";
        });

        if($api['connected'] == true) {
            if($api['logged'] == false) {
                echo "Send login ({$api['user']}, {$api['pass']})...\n";
                $connection->write("LOGIN USER:{$api['user']} PASSWORD:{$api['pass']}\r\n\r\n");
            } 
        }

    }, function (Exception $error) {
        echo "Failed to connect due to $error ????\n";
        exit(1);
    }
);
$loop->run();

?>
